using System;

class Program
{
    static void Main(string[] args)
    {
        int w, h, r, q;
        string[] s = Console.ReadLine().Split(' ');
        w = int.Parse(s[0]); h = int.Parse(s[1]);
        r = int.Parse(s[2]); q = int.Parse(s[3]);
        for (int i = 0; i < q; i++)
        {
            s = Console.ReadLine().Split(' ');
            int t = int.Parse(s[0]);
            if (t == 1)
            {
                int x = int.Parse(s[1]); int y = int.Parse(s[2]);
            }
            if (t == 2)
            {
                int x = int.Parse(s[1]);
                Console.WriteLine(h);
            }
        }
    }
}